package org.jayson.azureus.percentDownloadedItem;

import org.gudy.azureus2.plugins.PluginInterface;
import org.gudy.azureus2.plugins.download.Download;
import org.gudy.azureus2.plugins.utils.Formatters;
import org.gudy.azureus2.plugins.ui.tables.TableCell;
import org.gudy.azureus2.plugins.ui.tables.TableCellAddedListener;
import org.gudy.azureus2.plugins.ui.tables.TableCellDisposeListener;
import org.gudy.azureus2.plugins.ui.tables.TableCellRefreshListener;

public class PercentDownloadedItem implements TableCellRefreshListener, TableCellDisposeListener, TableCellAddedListener {
    
    private Formatters formatters;
	
	public PercentDownloadedItem(PluginInterface pi) {
		super();
		formatters = pi.getUtilities().getFormatters();
	}
    
    public void refresh(TableCell cell) {
        Object dataSource = cell.getDataSource();
        if (dataSource == null || ! (dataSource instanceof Download)) {
            return;
        }        
        Download download = (Download) dataSource;
        
                
        int completed = download.getStats().getDownloadCompleted(false);
        String cellText = formatters.formatPercentFromThousands(completed);
        if (!cell.setSortValue(completed) && cell.isValid()) {
            // if nothing has changed, do nothing
            return;
        }
        
        cell.setText(cellText);
    }
    
    public void cellAdded(TableCell cell) {
    	
    }
    
    public void dispose(TableCell cell) {
    	
    }
    
}