package org.jayson.azureus.percentDownloadedItem;

import org.gudy.azureus2.plugins.Plugin;
import org.gudy.azureus2.plugins.PluginException;
import org.gudy.azureus2.plugins.PluginInterface;
import org.gudy.azureus2.plugins.ui.UIManager;
import org.gudy.azureus2.plugins.ui.tables.TableColumn;
import org.gudy.azureus2.plugins.ui.tables.TableManager;

public class PercentDownloadedItemPlugin implements Plugin {
	private final static String COLUMN_ID_PERCENT_DOWNLOADED = "PercentDownloadedItem";
	
	public PercentDownloadedItemPlugin() {super();}
	
	public void initialize(PluginInterface pluginInterface) throws PluginException {
		UIManager uiManager = pluginInterface.getUIManager();
		
		TableManager tableManager = uiManager.getTableManager();
		TableColumn percentColumnIncomplete = tableManager.createColumn(TableManager.TABLE_MYTORRENTS_INCOMPLETE, COLUMN_ID_PERCENT_DOWNLOADED);
		TableColumn percentColumnComplete = tableManager.createColumn(TableManager.TABLE_MYTORRENTS_COMPLETE, COLUMN_ID_PERCENT_DOWNLOADED);
		
		PercentDownloadedItem percentDone = new PercentDownloadedItem(pluginInterface);
		
		percentColumnIncomplete.setAlignment(TableColumn.ALIGN_TRAIL);
		percentColumnIncomplete.setPosition(TableColumn.POSITION_LAST);
		percentColumnIncomplete.setWidth(80);
		percentColumnIncomplete.setRefreshInterval(TableColumn.INTERVAL_LIVE);
		percentColumnIncomplete.setType(TableColumn.TYPE_TEXT_ONLY);
		
		percentColumnIncomplete.addCellAddedListener(percentDone);
		percentColumnIncomplete.addCellDisposeListener(percentDone);
		percentColumnIncomplete.addCellRefreshListener(percentDone);
		
		tableManager.addColumn(percentColumnIncomplete);
		
		percentColumnComplete.setAlignment(TableColumn.ALIGN_TRAIL);
		percentColumnComplete.setPosition(TableColumn.POSITION_INVISIBLE);
		percentColumnComplete.setWidth(80);
		percentColumnComplete.setRefreshInterval(TableColumn.INTERVAL_LIVE);
		percentColumnComplete.setType(TableColumn.TYPE_TEXT_ONLY);
		
		percentColumnComplete.addCellAddedListener(percentDone);
		percentColumnComplete.addCellDisposeListener(percentDone);
		percentColumnComplete.addCellRefreshListener(percentDone);
		
		tableManager.addColumn(percentColumnComplete);
	}
	
}